my $dllname = $ARGV[0];
$dllname =~ s/\.dll//i;

my $wrapper_def = 'win2k_xp_' . $dllname . '.def';
my $org_unknown_def = $dllname . '_org_unknown.def';

open(WRAPPER_DEF,     ">${wrapper_def}");
open(ORG_UNKNOWN_DEF, ">${org_unknown_def}");

print WRAPPER_DEF     "LIBRARY ${dllname}.dll\n";
print ORG_UNKNOWN_DEF "LIBRARY ${dllname}_ORG.dll\n";

print WRAPPER_DEF     "VERSION 5.0\n";
print ORG_UNKNOWN_DEF "VERSION 5.0\n";

print WRAPPER_DEF     "EXPORTS\n";
print ORG_UNKNOWN_DEF "EXPORTS\n";

my @dumpbin = `dumpbin.exe /exports $ARGV[0]`;
foreach (@dumpbin) {
	if ($_ =~ /(\d+)[ \dA-F]+[\dA-F]{8} ([\[\]_A-Z\da-z]+)/) {
		if($2 eq '[NONAME]') {
			print WRAPPER_DEF     "NONAME_${1}=${dllname}_ORG.#${1} \@${1} NONAME\n";
			print ORG_UNKNOWN_DEF "NONAME_${1} \@${1}\n";
		} else {
			print WRAPPER_DEF     "${2}=${dllname}_ORG.${2} \@${1}\n";
			print ORG_UNKNOWN_DEF "${2}\n";
		}
	}
}

close(WRAPPER_DEF);
close(ORG_UNKNOWN_DEF);

open(MAKEFILE, ">makefile");
print MAKEFILE "${dllname}.dll : ${dllname}_org_unknown.lib ${wrapper_def}\n";
print MAKEFILE     "\tlink /def:${wrapper_def} /subsystem:console /dll /release ${dllname}_org_unknown.lib libcmt.lib\n";
print MAKEFILE "\n";
print MAKEFILE "${dllname}_org_unknown.lib : ${dllname}_org_unknown.def\n";
print MAKEFILE     "\tlib /def:${dllname}_org_unknown.def\n";
print MAKEFILE "\n";
close(MAKEFILE);

