/*
  Windows 2000 XP API Wrapper Pack
  Copyright (C) 2008 OldCigarette

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <windows.h>
#include <psapi.h>

extern "C" {

BOOL WINAPI
WTSRegisterSessionNotification(
    HWND hWnd,
    DWORD dwFlags
	) {
	return TRUE;
}

BOOL WINAPI
WTSUnRegisterSessionNotification(
    HWND hWnd) {
	return TRUE;
}

BOOL WINAPI WTSQueryUserToken(ULONG SessionId, PHANDLE phToken) {
    DWORD aProcesses[1024];
    DWORD dwNeeded = 0;
    DWORD dwProcesses = 0;
   
    if(!EnumProcesses(aProcesses, sizeof(aProcesses), &dwNeeded)) {
        return FALSE;
    }   
    dwProcesses = dwNeeded / sizeof(DWORD);

    HANDLE hProcess = NULL;
    char szProcessName[MAX_PATH];
    char szDrive      [MAX_PATH];
    char szDir        [MAX_PATH];
    char szName       [MAX_PATH];
    char szExt        [MAX_PATH];
    DWORD dwExplorerSessionID = 0;
    DWORD dwRetLength = 0;

    for(DWORD i=0; i < dwProcesses; i++) {
        ZeroMemory(szProcessName, MAX_PATH);
        ZeroMemory(szDrive,       MAX_PATH);
        ZeroMemory(szDir,         MAX_PATH);
        ZeroMemory(szName,        MAX_PATH);
        ZeroMemory(szExt,         MAX_PATH);
       
        hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, aProcesses[i]);
       
        if(hProcess) {
            if(GetModuleFileNameEx(hProcess, NULL, szProcessName, sizeof(szProcessName))) {
                _splitpath(szProcessName, szDrive, szDir, szName, szExt);
                if( (stricmp("explorer", szName) == 0) && (stricmp(".exe", szExt) == 0) ) {
                    if(OpenProcessToken(hProcess, TOKEN_DUPLICATE|TOKEN_QUERY|TOKEN_IMPERSONATE, phToken)) {
                        if(GetTokenInformation(*phToken, TokenSessionId, &dwExplorerSessionID, sizeof(DWORD), &dwRetLength)) {
                            if(dwExplorerSessionID == SessionId) {
                                CloseHandle(hProcess);
                                return TRUE;
                            }
                        }
						CloseHandle(*phToken);
                    }
                }
            }
            CloseHandle(hProcess);
        }
    }

    return FALSE;
}

} // extern "C"

